Index: Makefile.am
===================================================================
--- Makefile.am	(revision ce35060c0b8f538bfc2659317d8bf70e8a2adbf7)
+++ Makefile.am	(revision 3535a6e36df4c6beed134aef3f7f81c7f9ea6dd2)
@@ -45,5 +45,5 @@
      aim.c buddy.c buddylist.c style.c errqueue.c \
      zbuddylist.c popexec.c select.c wcwidth.c \
-     glib_compat.c mainpanel.c msgwin.c sepbar.c editcontext.c
+     glib_compat.c mainpanel.c msgwin.c sepbar.c editcontext.c signal.c
 
 NORMAL_SRCS = filterproc.c window.c windowcb.c
Index: README
===================================================================
--- README	(revision aeadc748f353cd0be4ebfa805d85577c9c7498fa)
+++ README	(revision 13ee8f2b200092c55bc8af13b46ca948c16dcd94)
@@ -18,4 +18,5 @@
 BarnOwl currently requires the following perl modules off of CPAN:
 
+AnyEvent
 PAR
 Net::DNS
@@ -30,5 +31,5 @@
 The IRC module requires:
 
-Net::IRC
+AnyEvent::IRC
 Class::Accessor
 
Index: aim.c
===================================================================
--- aim.c	(revision 3472845ecdabe9cd1549dd2b2355ca745059ea36)
+++ aim.c	(revision dc1edbded39e57c67e8049c2960f0c235cd5afb5)
@@ -446,7 +446,6 @@
 }
 
-int owl_aim_process_events(void)
-{
-  aim_session_t *aimsess;
+int owl_aim_process_events(aim_session_t *aimsess)
+{
   aim_conn_t *waitingconn = NULL;
   struct timeval tv;
@@ -454,5 +453,4 @@
   struct owlfaim_priv *priv;
 
-  aimsess=owl_global_get_aimsess(&g);
   priv = aimsess->aux_data;
 
@@ -1795,8 +1793,113 @@
 }
 
-void owl_process_aim(void)
-{
-  if (owl_global_is_doaimevents(&g)) {
-    owl_aim_process_events();
-  }
-}
+typedef struct _owl_aim_event_source { /*noproto*/
+  GSource source;
+  aim_session_t *sess;
+  GPtrArray *fds;
+} owl_aim_event_source;
+
+static void truncate_pollfd_list(owl_aim_event_source *event_source, int len)
+{
+  GPollFD *fd;
+  int i;
+  if (len < event_source->fds->len)
+    owl_function_debugmsg("Truncating AIM PollFDs to %d, was %d", len, event_source->fds->len);
+  for (i = len; i < event_source->fds->len; i++) {
+    fd = event_source->fds->pdata[i];
+    g_source_remove_poll(&event_source->source, fd);
+    g_free(fd);
+  }
+  g_ptr_array_remove_range(event_source->fds, len, event_source->fds->len - len);
+}
+
+static gboolean owl_aim_event_source_prepare(GSource *source, int *timeout)
+{
+  owl_aim_event_source *event_source = (owl_aim_event_source*)source;
+  aim_conn_t *cur;
+  GPollFD *fd;
+  int i;
+
+  /* AIM HACK:
+   *
+   *  The problem - I'm not sure where to hook into the owl/faim
+   *  interface to keep track of when the AIM socket(s) open and
+   *  close. In particular, the bosconn thing throws me off. So,
+   *  rather than register particular dispatchers for AIM, I look up
+   *  the relevant FDs and add them to select's watch lists, then
+   *  check for them individually before moving on to the other
+   *  dispatchers. --asedeno
+   */
+  i = 0;
+  for (cur = event_source->sess->connlist; cur; cur = cur->next) {
+    if (cur->fd != -1) {
+      /* Add new GPollFDs as necessary. */
+      if (i == event_source->fds->len) {
+	fd = g_new0(GPollFD, 1);
+	g_ptr_array_add(event_source->fds, fd);
+	g_source_add_poll(source, fd);
+        owl_function_debugmsg("Allocated new AIM PollFD, len = %d", event_source->fds->len);
+      }
+      fd = event_source->fds->pdata[i];
+      fd->fd = cur->fd;
+      fd->events |= G_IO_IN | G_IO_HUP | G_IO_ERR;
+      if (cur->status & AIM_CONN_STATUS_INPROGRESS) {
+        /* Yes, we're checking writable sockets here. Without it, AIM
+           login is really slow. */
+	fd->events |= G_IO_OUT;
+      }
+      i++;
+    }
+  }
+  /* If the number of GPollFDs went down, clean up. */
+  truncate_pollfd_list(event_source, i);
+
+  *timeout = -1;
+  return FALSE;
+}
+
+static gboolean owl_aim_event_source_check(GSource *source)
+{
+  owl_aim_event_source *event_source = (owl_aim_event_source*)source;
+  int i;
+
+  for (i = 0; i < event_source->fds->len; i++) {
+    GPollFD *fd = event_source->fds->pdata[i];
+    if (fd->revents & fd->events)
+      return TRUE;
+  }
+  return FALSE;
+}
+
+static gboolean owl_aim_event_source_dispatch(GSource *source, GSourceFunc callback, gpointer user_data)
+{
+  owl_aim_event_source *event_source = (owl_aim_event_source*)source;
+  owl_aim_process_events(event_source->sess);
+  return TRUE;
+}
+
+static void owl_aim_event_source_finalize(GSource *source)
+{
+  owl_aim_event_source *event_source = (owl_aim_event_source*)source;
+  truncate_pollfd_list(event_source, 0);
+  g_ptr_array_free(event_source->fds, TRUE);
+}
+
+static GSourceFuncs aim_event_funcs = {
+  owl_aim_event_source_prepare,
+  owl_aim_event_source_check,
+  owl_aim_event_source_dispatch,
+  owl_aim_event_source_finalize,
+};
+
+GSource *owl_aim_event_source_new(aim_session_t *sess)
+{
+  GSource *source;
+  owl_aim_event_source *event_source;
+
+  source = g_source_new(&aim_event_funcs, sizeof(owl_aim_event_source));
+  event_source = (owl_aim_event_source *)source;
+  event_source->sess = sess;
+  /* TODO: When we depend on glib 2.22+, use g_ptr_array_new_with_free_func. */
+  event_source->fds = g_ptr_array_new();
+  return source;
+}
Index: cmd.c
===================================================================
--- cmd.c	(revision 6a7111370ea0e1de2c3eb86a85f34cd68848d4b1)
+++ cmd.c	(revision 4c7c21f786a0416a755645b78db0b851f75f8748)
@@ -12,12 +12,11 @@
 
 int owl_cmddict_setup(owl_cmddict *cd) {
-  if (0 != owl_cmddict_init(cd)) return(-1);
+  owl_cmddict_init(cd);
   if (0 != owl_cmddict_add_from_list(cd, commands_to_init)) return(-1);
   return(0);
 }
 
-int owl_cmddict_init(owl_cmddict *cd) {
-  if (owl_dict_create(cd)) return(-1);
-  return(0);
+void owl_cmddict_init(owl_cmddict *cd) {
+  owl_dict_create(cd);
 }
 
@@ -135,9 +134,9 @@
 void owl_cmd_cleanup(owl_cmd *cmd)
 {
-  if (cmd->name) g_free(cmd->name);
-  if (cmd->summary) g_free(cmd->summary);
-  if (cmd->usage) g_free(cmd->usage);
-  if (cmd->description) g_free(cmd->description);
-  if (cmd->cmd_aliased_to) g_free(cmd->cmd_aliased_to);
+  g_free(cmd->name);
+  g_free(cmd->summary);
+  g_free(cmd->usage);
+  g_free(cmd->description);
+  g_free(cmd->cmd_aliased_to);
   if (cmd->cmd_perl) owl_perlconfig_cmd_cleanup(cmd);
 }
Index: commands.c
===================================================================
--- commands.c	(revision c809f5e8a3cc2745724f518c89b09279b5508b02)
+++ commands.c	(revision 697221fc51f0060043c93821f0358317f6bc6ab0)
@@ -281,6 +281,6 @@
   OWLCMD_ARGS("punt", owl_command_punt, OWL_CTX_ANY,
 	      "suppress an arbitrary filter",
-	      "punt <filter-text>",
-	      "punt <filter-text (multiple words)>\n"
+	      "punt <filter-name>\n"
+	      "punt <filter-text (multiple words)>",
 	      "The punt command will suppress messages to the specified\n"
 	      "filter\n\n"
@@ -289,10 +289,10 @@
   OWLCMD_ARGS("unpunt", owl_command_unpunt, OWL_CTX_ANY,
 	      "remove an entry from the punt list",
-	      "unpunt <filter-text>\n"
-	      "unpunt <filter-text>\n"
-	      "unpunt <number>\n",
+	      "unpunt <number>\n"
+	      "unpunt <filter-name>\n"
+	      "unpunt <filter-text (multiple words)>",
 	      "The unpunt command will remove an entry from the puntlist.\n"
-	      "The first two forms correspond to the first two forms of the :punt\n"
-	      "command. The latter allows you to remove a specific entry from the\n"
+	      "The last two forms correspond to the two forms of the :punt\n"
+	      "command. The first allows you to remove a specific entry from\n"
 	      "the list (see :show zpunts)\n\n"
 	      "SEE ALSO:  punt, zpunt, zunpunt, show zpunts\n"),
@@ -1288,5 +1288,5 @@
   }
   owl_function_nextmsg_full(filter, skip_deleted, last_if_none);
-  if (filter) g_free(filter);
+  g_free(filter);
   return(NULL);
 }
@@ -1318,5 +1318,5 @@
   }
   owl_function_prevmsg_full(filter, skip_deleted, first_if_none);
-  if (filter) g_free(filter);
+  g_free(filter);
   return(NULL);
 }
@@ -1691,7 +1691,5 @@
   commands = g_strsplit_set(newbuff, ";", 0);
   for (i = 0; commands[i] != NULL; i++) {
-    if (lastrv) {
-      g_free(lastrv);
-    }
+    g_free(lastrv);
     lastrv = owl_function_command(commands[i]);
   }
@@ -2466,5 +2464,4 @@
   owl_list * fl;
   owl_filter * f;
-  char * text;
   int i;
 
@@ -2482,12 +2479,12 @@
         return;
       } else {
-        owl_function_error("No such filter number: %d", i+1);
+        owl_function_makemsg("No such filter number: %d.", i+1);
       }
     }
-    text = owl_string_build_quoted("filter %q", argv[1]);
-    owl_function_punt(text, unpunt);
-    g_free(text);
+    const char *filter[] = {"filter", argv[1]};
+    owl_function_punt(2, filter, unpunt);
   } else {
-    owl_function_punt(skiptokens(buff, 1), unpunt);
+    /* Pass in argv[1]..argv[argc-1]. */
+    owl_function_punt(argc - 1, argv + 1, unpunt);
   }
 }
Index: configure.ac
===================================================================
--- configure.ac	(revision 28da2daf4548256b44d1fd586200032e96462d57)
+++ configure.ac	(revision 125536565b016a2dc0130569f6192cfebbe39f49)
@@ -115,5 +115,5 @@
 
 dnl Add CFLAGS and LIBS for glib-2.0
-PKG_CHECK_MODULES(GLIB,[glib-2.0 gobject-2.0])
+PKG_CHECK_MODULES(GLIB,[glib-2.0 >= 2.12 gobject-2.0 gthread-2.0])
 
 AC_MSG_NOTICE([Adding glib-2.0 CFLAGS ${GLIB_CFLAGS}])
Index: dict.c
===================================================================
--- dict.c	(revision f25df21f6284aedd48c098bc68cee9896da5ce98)
+++ dict.c	(revision 4c7c21f786a0416a755645b78db0b851f75f8748)
@@ -15,10 +15,8 @@
 #define GROWBY 3 / 2
 
-int owl_dict_create(owl_dict *d) {
+void owl_dict_create(owl_dict *d) {
   d->size=0;
   d->els=g_new(owl_dict_el, INITSIZE);
   d->avail=INITSIZE;
-  if (d->els==NULL) return(-1);
-  return(0);
 }
 
@@ -60,12 +58,9 @@
 /* Appends dictionary keys to a list.  Duplicates the keys,
  * so they will need to be freed by the caller. */
-int owl_dict_get_keys(const owl_dict *d, owl_list *l) {
+void owl_dict_get_keys(const owl_dict *d, owl_list *l) {
   int i;
-  char *dupk;
   for (i=0; i<d->size; i++) {
-    if ((dupk = g_strdup(d->els[i].k)) == NULL) return(-1);
-    owl_list_append_element(l, dupk);
+    owl_list_append_element(l, g_strdup(d->els[i].k));
   }
-  return(0);
 }
 
@@ -84,5 +79,4 @@
 {
   int pos, found;
-  char *dupk;
   found = _owl_dict_find_pos(d, k, &pos);
   if (found && delete_on_replace) {
@@ -99,5 +93,4 @@
       if (d->els==NULL) return(-1);
     }
-    if ((dupk = g_strdup(k)) == NULL) return(-1);
     if (pos!=d->size) {
       /* shift forward to leave us a slot */
@@ -106,5 +99,5 @@
     }
     d->size++;
-    d->els[pos].k = dupk;
+    d->els[pos].k = g_strdup(k);
     d->els[pos].v = v;    
     return(0);
Index: editwin.c
===================================================================
--- editwin.c	(revision 47e0a6a50d1c08ec05030b2507b3f1a84b618a9f)
+++ editwin.c	(revision 3b8a563ae4e07b1064fe005714793565ac720dc4)
@@ -317,6 +317,5 @@
   }
 
-  if (locktext)
-    g_free(locktext);
+  g_free(locktext);
 
   oe_set_index(e, lock);
Index: filterproc.c
===================================================================
--- filterproc.c	(revision 8bd190d63b2f2c09ea416e7be7c51d974f56bfaf)
+++ filterproc.c	(revision e2cc8487b365b026214922326e880825057eb9e6)
@@ -17,5 +17,4 @@
   int err = 0;
   struct pollfd fds[2];
-  struct sigaction sig = {.sa_handler = SIG_IGN}, old;
 
   fcntl(rfd, F_SETFL, O_NONBLOCK | fcntl(rfd, F_GETFL));
@@ -27,6 +26,4 @@
   fds[1].events = POLLOUT;
 
-  sigaction(SIGPIPE, &sig, &old);
-  
   while(1) {
     if(out && *out) {
@@ -67,5 +64,4 @@
 
   *in = g_string_free(str, err < 0);
-  sigaction(SIGPIPE, &old, NULL);
   return err;
 }
Index: fmtext.c
===================================================================
--- fmtext.c	(revision 4479497945518a0fe5ddc9e5cf08f98bc7990cd9)
+++ fmtext.c	(revision 7b4f3bea704ed82f2c36ba19fcf354d7442a5bb7)
@@ -184,14 +184,7 @@
 }
 
-static void _owl_fmtext_update_colorpair(short fg, short bg, short *pair)
-{
-  if (owl_global_get_hascolors(&g)) {
-    *pair = owl_fmtext_get_colorpair(fg, bg);
-  }
-}
-
 static void _owl_fmtext_wcolor_set(WINDOW *w, short pair)
 {
-  if (owl_global_get_hascolors(&g)) {
+  if (has_colors()) {
       wcolor_set(w,pair,NULL);
       wbkgdset(w, COLOR_PAIR(pair));
@@ -221,5 +214,5 @@
   bg = default_bgcolor;
   _owl_fmtext_wattrset(w, attr);
-  _owl_fmtext_update_colorpair(fg, bg, &pair);
+  pair = owl_fmtext_get_colorpair(fg, bg);
   _owl_fmtext_wcolor_set(w, pair);
 
@@ -270,5 +263,5 @@
       if (bg == OWL_COLOR_DEFAULT) bg = default_bgcolor;
       _owl_fmtext_wattrset(w, attr);
-      _owl_fmtext_update_colorpair(fg, bg, &pair);
+      pair = owl_fmtext_get_colorpair(fg, bg);
       _owl_fmtext_wcolor_set(w, pair);
 
@@ -662,5 +655,4 @@
            continue */
       } else if (!strcasecmp(buff, "@color") 
-                 && owl_global_get_hascolors(&g)
                  && owl_global_is_colorztext(&g)) {
         g_free(buff);
@@ -820,5 +812,5 @@
     }
   }
-  if (owl_global_get_hascolors(&g)) {
+  if (has_colors()) {
     for(i = 0; i < 8; i++) {
       short fg, bg;
@@ -835,4 +827,7 @@
   owl_colorpair_mgr *cpmgr;
   short pair;
+
+  if (!has_colors())
+    return 0;
 
   /* Sanity (Bounds) Check */
@@ -852,5 +847,5 @@
   if (!(pair != -1 && pair < cpmgr->next)) {
     /* If we didn't find a pair, search for a free one to assign. */
-    pair = (cpmgr->next < COLOR_PAIRS) ? cpmgr->next : -1;
+    pair = (cpmgr->next < owl_util_get_colorpairs()) ? cpmgr->next : -1;
     if (pair != -1) {
       /* We found a free pair, initialize it. */
Index: functions.c
===================================================================
--- functions.c	(revision 4fd211f3a533efcedaf4d0dc7c01e02087ad2e39)
+++ functions.c	(revision 259e60a8abc2d2d41bc7a484b02a334fdd13857f)
@@ -32,5 +32,5 @@
   char *rv;
   rv=owl_function_command(cmdbuff);
-  if (rv) g_free(rv);
+  g_free(rv);
 }
 
@@ -453,5 +453,5 @@
 
   if (rv || status) {
-    if(cryptmsg) g_free(cryptmsg);
+    g_free(cryptmsg);
     g_free(old_msg);
     owl_function_error("Error in zcrypt, possibly no key found.  Message not sent.");
@@ -991,5 +991,5 @@
   /* execute the commands in shutdown */
   ret = owl_perlconfig_execute("BarnOwl::Hooks::_shutdown();");
-  if (ret) g_free(ret);
+  g_free(ret);
 
   /* signal our child process, if any */
@@ -1408,6 +1408,6 @@
 #ifdef HAVE_LIBZEPHYR
     if (owl_message_is_direction_in(m)) {
-      char *ptr, tmpbuff[1024];
-      int i, j, fields, len;
+      char *tmpbuff;
+      int i, fields;
 
       n=owl_message_get_notice(m);
@@ -1453,23 +1453,12 @@
 	owl_fmtext_appendf_normal(&fm, "  Fields    : %i\n", fields);
 
-	for (i=0; i<fields; i++) {
-	  ptr=owl_zephyr_get_field_as_utf8(n, i+1);
-	  len=strlen(ptr);
-	  if (len<30) {
-	    strncpy(tmpbuff, ptr, len);
-	    tmpbuff[len]='\0';
-	  } else {
-	    strncpy(tmpbuff, ptr, 30);
-	    tmpbuff[30]='\0';
-	    strcat(tmpbuff, "...");
-	  }
-	  g_free(ptr);
-
-	  for (j=0; j<strlen(tmpbuff); j++) {
-	    if (tmpbuff[j]=='\n') tmpbuff[j]='~';
-	    if (tmpbuff[j]=='\r') tmpbuff[j]='!';
-	  }
-
-	  owl_fmtext_appendf_normal(&fm, "  Field %i   : %s\n", i+1, tmpbuff);
+	for (i = 0; i < fields; i++) {
+	  tmpbuff = owl_zephyr_get_field_as_utf8(n, i + 1);
+
+	  g_strdelimit(tmpbuff, "\n", '~');
+	  g_strdelimit(tmpbuff, "\r", '!');
+
+	  owl_fmtext_appendf_normal(&fm, "  Field %i   : %s\n", i + 1, tmpbuff);
+	  g_free(tmpbuff);
 	}
 	owl_fmtext_appendf_normal(&fm, "  Default Fm: %s\n", n->z_default_format);
@@ -1817,7 +1806,7 @@
 	  owl_global_get_cols(&g));
 
-  if (owl_global_get_hascolors(&g)) {
+  if (has_colors()) {
     owl_fmtext_append_normal(&fm, "Color: Yes\n");
-    owl_fmtext_appendf_normal(&fm, "Number of color pairs: %i\n", owl_global_get_colorpairs(&g));
+    owl_fmtext_appendf_normal(&fm, "Number of color pairs: %i\n", owl_util_get_colorpairs());
     owl_fmtext_appendf_normal(&fm, "Can change colors: %s\n", can_change_color() ? "yes" : "no");
   } else {
@@ -2226,9 +2215,7 @@
     f = fl->data;
     owl_fmtext_append_normal(&fm, "   ");
-    if (owl_global_get_hascolors(&g)) {
-      owl_fmtext_append_normal_color(&fm, owl_filter_get_name(f), owl_filter_get_fgcolor(f), owl_filter_get_bgcolor(f));
-    } else {
-      owl_fmtext_append_normal(&fm, owl_filter_get_name(f));
-    }
+    owl_fmtext_append_normal_color(&fm, owl_filter_get_name(f),
+                                   owl_filter_get_fgcolor(f),
+                                   owl_filter_get_bgcolor(f));
     owl_fmtext_append_normal(&fm, "\n");
   }
@@ -2360,7 +2347,5 @@
 done:
   g_free(class);
-  if (instance) {
-    g_free(instance);
-  }
+  g_free(instance);
   return(filtname);
 }
@@ -2523,5 +2508,5 @@
 
   filtname = g_strdup_printf("conversation-%s", ccs);
-  owl_text_tr(filtname, ' ', '-');
+  g_strdelimit(filtname, " ", '-');
 
   if (owl_global_get_filter(&g, filtname)) {
@@ -2785,24 +2770,30 @@
 void owl_function_zpunt(const char *class, const char *inst, const char *recip, int direction)
 {
-  GString *buf;
+  GPtrArray *argv;
   char *quoted;
 
-  buf = g_string_new("");
+  argv = g_ptr_array_new();
   if (!strcmp(class, "*")) {
-    g_string_append(buf, "class .*");
+    g_ptr_array_add(argv, g_strdup("class"));
+    g_ptr_array_add(argv, g_strdup(".*"));
   } else {
     quoted=owl_text_quote(class, OWL_REGEX_QUOTECHARS, OWL_REGEX_QUOTEWITH);
-    owl_string_appendf_quoted(buf, "class ^(un)*%q(\\.d)*$", quoted);
+    g_ptr_array_add(argv, g_strdup("class"));
+    g_ptr_array_add(argv, g_strdup_printf("^(un)*%s(\\.d)*$", quoted));
     g_free(quoted);
   }
   if (!strcmp(inst, "*")) {
-    g_string_append(buf, " and instance .*");
+    g_ptr_array_add(argv, g_strdup("and"));
+    g_ptr_array_add(argv, g_strdup("instance"));
+    g_ptr_array_add(argv, g_strdup(".*"));
   } else {
     quoted=owl_text_quote(inst, OWL_REGEX_QUOTECHARS, OWL_REGEX_QUOTEWITH);
-    owl_string_appendf_quoted(buf, " and instance ^(un)*%q(\\.d)*$", quoted);
+    g_ptr_array_add(argv, g_strdup("and"));
+    g_ptr_array_add(argv, g_strdup("instance"));
+    g_ptr_array_add(argv, g_strdup_printf("^(un)*%s(\\.d)*$", quoted));
     g_free(quoted);
   }
   if (!strcmp(recip, "*")) {
-    /* g_string_append(buf, ""); */
+    /* nothing */
   } else {
     if(!strcmp(recip, "%me%")) {
@@ -2810,13 +2801,16 @@
     }
     quoted=owl_text_quote(recip, OWL_REGEX_QUOTECHARS, OWL_REGEX_QUOTEWITH);
-    owl_string_appendf_quoted(buf, " and recipient ^%q$", quoted);
+    g_ptr_array_add(argv, g_strdup("and"));
+    g_ptr_array_add(argv, g_strdup("recipient"));
+    g_ptr_array_add(argv, g_strdup_printf("^%s$", quoted));
     g_free(quoted);
   }
 
-  owl_function_punt(buf->str, direction);
-  g_string_free(buf, true);
-}
-
-void owl_function_punt(const char *filter, int direction)
+  owl_function_punt(argv->len, (const char *const*) argv->pdata, direction);
+  g_ptr_array_foreach(argv, (GFunc)g_free, NULL);
+  g_ptr_array_free(argv, true);
+}
+
+void owl_function_punt(int argc, const char *const *argv, int direction)
 {
   owl_filter *f;
@@ -2826,6 +2820,5 @@
 
   /* first, create the filter */
-  owl_function_debugmsg("About to filter %s", filter);
-  f = owl_filter_new_fromstring("punt-filter", filter);
+  f = owl_filter_new("punt-filter", argc, argv);
   if (f == NULL) {
     owl_function_error("Error creating filter for zpunt");
@@ -2854,9 +2847,11 @@
   }
 
-  owl_function_debugmsg("punting");
-  /* If we're punting, add the filter to the global punt list */
-  if (direction==0) {
+  if (direction == 0) {
+    owl_function_debugmsg("punting");
+    /* If we're punting, add the filter to the global punt list */
     owl_list_append_element(fl, f);
-  }
+  } else if (direction == 1) {
+    owl_function_makemsg("No matching punt filter");
+ }
 }
 
@@ -2995,13 +2990,9 @@
       i--;
     }
-    owl_function_mask_sigint(NULL);
-    if(owl_global_is_interrupted(&g)) {
-      owl_global_unset_interrupted(&g);
-      owl_function_unmask_sigint(NULL);
+    if (owl_global_take_interrupt(&g)) {
       owl_function_makemsg("Search interrupted!");
       owl_mainwin_redisplay(owl_global_get_mainwin(&g));
       return;
     }
-    owl_function_unmask_sigint(NULL);
   }
   owl_mainwin_redisplay(owl_global_get_mainwin(&g));
@@ -3086,14 +3077,9 @@
           ret=ZLocateUser(zstr(user), &numlocs, ZAUTH);
 
-          owl_function_mask_sigint(NULL);
-          if(owl_global_is_interrupted(&g)) {
+	  if (owl_global_take_interrupt(&g)) {
             interrupted = 1;
-            owl_global_unset_interrupted(&g);
-            owl_function_unmask_sigint(NULL);
             owl_function_makemsg("Interrupted!");
             break;
           }
-
-          owl_function_unmask_sigint(NULL);
 
           if (ret!=ZERR_NONE) {
@@ -3256,6 +3242,7 @@
   filename=owl_global_get_startupfile(&g);
 
-  /* delete earlier copies */
-  owl_util_file_deleteline(filename, buff, 1);
+  /* delete earlier copies, if the file exists */
+  if (g_file_test(filename, G_FILE_TEST_EXISTS))
+    owl_util_file_deleteline(filename, buff, 1);
 
   file=fopen(filename, "a");
@@ -3500,20 +3487,4 @@
 }
 
-void owl_function_mask_sigint(sigset_t *oldmask) {
-  sigset_t intr;
-
-  sigemptyset(&intr);
-  sigaddset(&intr, SIGINT);
-  sigprocmask(SIG_BLOCK, &intr, oldmask);
-}
-
-void owl_function_unmask_sigint(sigset_t *oldmask) {
-  sigset_t intr;
-
-  sigemptyset(&intr);
-  sigaddset(&intr, SIGINT);
-  sigprocmask(SIG_UNBLOCK, &intr, oldmask);
-}
-
 void _owl_function_mark_message(const owl_message *m)
 {
Index: global.c
===================================================================
--- global.c	(revision 47e0a6a50d1c08ec05030b2507b3f1a84b618a9f)
+++ global.c	(revision dc1edbded39e57c67e8049c2960f0c235cd5afb5)
@@ -16,4 +16,7 @@
 
   g_type_init();
+  g_thread_init(NULL);
+
+  owl_select_init();
 
   g->lines=LINES;
@@ -51,8 +54,4 @@
   g->direction=OWL_DIRECTION_DOWNWARDS;
   g->zaway=0;
-  if (has_colors()) {
-    g->hascolors=1;
-  }
-  g->colorpairs=COLOR_PAIRS;
   owl_fmtext_init_colorpair_mgr(&(g->cpmgr));
   g->debug=OWL_DEBUG;
@@ -99,5 +98,4 @@
 
   owl_errqueue_init(&(g->errqueue));
-  g->got_err_signal=0;
 
   owl_zbuddylist_create(&(g->zbuddies));
@@ -108,8 +106,9 @@
   owl_message_init_fmtext_cache();
   owl_list_create(&(g->io_dispatch_list));
-  owl_list_create(&(g->psa_list));
   g->timerlist = NULL;
-  g->interrupted = FALSE;
   g->kill_buffer = NULL;
+
+  g->interrupt_count = 0;
+  g->interrupt_lock = g_mutex_new();
 }
 
@@ -348,5 +347,5 @@
 
 void owl_global_set_resize_pending(owl_global *g) {
-  g->resizepending=1;
+  g->resizepending = true;
 }
 
@@ -448,5 +447,5 @@
   /* resize the screen.  If lines or cols is 0 use the terminal size */
   if (!g->resizepending) return;
-  g->resizepending = 0;
+  g->resizepending = false;
 
   owl_global_get_terminal_size(&g->lines, &g->cols);
@@ -509,5 +508,5 @@
 
 void owl_global_set_startupargs(owl_global *g, int argc, char **argv) {
-  if (g->startupargs) g_free(g->startupargs);
+  g_free(g->startupargs);
   g->startupargs = g_strjoinv(" ", argv);
 }
@@ -574,17 +573,4 @@
 owl_view *owl_global_get_current_view(owl_global *g) {
   return(&(g->current_view));
-}
-
-/* has colors */
-
-int owl_global_get_hascolors(const owl_global *g) {
-  if (g->hascolors) return(1);
-  return(0);
-}
-
-/* color pairs */
-
-int owl_global_get_colorpairs(const owl_global *g) {
-  return(g->colorpairs);
 }
 
@@ -693,18 +679,24 @@
 }
 
-int owl_global_is_doaimevents(const owl_global *g)
-{
-  if (g->aim_doprocessing) return(1);
-  return(0);
+bool owl_global_is_doaimevents(const owl_global *g)
+{
+  return g->aim_event_source != NULL;
 }
 
 void owl_global_set_doaimevents(owl_global *g)
 {
-  g->aim_doprocessing=1;
+  if (g->aim_event_source)
+    return;
+  g->aim_event_source = owl_aim_event_source_new(owl_global_get_aimsess(g));
+  g_source_attach(g->aim_event_source, NULL);
 }
 
 void owl_global_set_no_doaimevents(owl_global *g)
 {
-  g->aim_doprocessing=0;
+  if (!g->aim_event_source)
+    return;
+  g_source_destroy(g->aim_event_source);
+  g_source_unref(g->aim_event_source);
+  g->aim_event_source = NULL;
 }
 
@@ -764,6 +756,6 @@
 }
 
-int owl_global_get_style_names(const owl_global *g, owl_list *l) {
-  return owl_dict_get_keys(&(g->styledict), l);
+void owl_global_get_style_names(const owl_global *g, owl_list *l) {
+  owl_dict_get_keys(&(g->styledict), l);
 }
 
@@ -824,28 +816,4 @@
 }
 
-void owl_global_set_errsignal(owl_global *g, int signum, siginfo_t *siginfo)
-{
-  g->got_err_signal = signum;
-  if (siginfo) {
-    g->err_signal_info = *siginfo;
-  } else {
-    siginfo_t si;
-    memset(&si, 0, sizeof(si));
-    g->err_signal_info = si;
-  }
-}
-
-int owl_global_get_errsignal_and_clear(owl_global *g, siginfo_t *siginfo)
-{
-  int signum;
-  if (siginfo && g->got_err_signal) {
-    *siginfo = g->err_signal_info;
-  } 
-  signum = g->got_err_signal;
-  g->got_err_signal = 0;
-  return signum;
-}
-
-
 owl_zbuddylist *owl_global_get_zephyr_buddylist(owl_global *g)
 {
@@ -878,24 +846,7 @@
 }
 
-owl_list *owl_global_get_psa_list(owl_global *g)
-{
-  return &(g->psa_list);
-}
-
 GList **owl_global_get_timerlist(owl_global *g)
 {
   return &(g->timerlist);
-}
-
-int owl_global_is_interrupted(const owl_global *g) {
-  return g->interrupted;
-}
-
-void owl_global_set_interrupted(owl_global *g) {
-  g->interrupted = 1;
-}
-
-void owl_global_unset_interrupted(owl_global *g) {
-  g->interrupted = 0;
 }
 
@@ -965,2 +916,21 @@
   g->kill_buffer = g_strndup(kill, len);
 }
+
+void owl_global_add_interrupt(owl_global *g) {
+  /* TODO: This can almost certainly be done with atomic
+   * operations. Whatever. */
+  g_mutex_lock(g->interrupt_lock);
+  g->interrupt_count++;
+  g_mutex_unlock(g->interrupt_lock);
+}
+
+bool owl_global_take_interrupt(owl_global *g) {
+  bool ans = false;
+  g_mutex_lock(g->interrupt_lock);
+  if (g->interrupt_count > 0) {
+    ans = true;
+    g->interrupt_count--;
+  }
+  g_mutex_unlock(g->interrupt_lock);
+  return ans;
+}
Index: keybinding.c
===================================================================
--- keybinding.c	(revision d07af84683f667d7c34814c1b0a12823b08f6df0)
+++ keybinding.c	(revision 3b8a563ae4e07b1064fe005714793565ac720dc4)
@@ -69,7 +69,7 @@
 void owl_keybinding_delete(owl_keybinding *kb)
 {
-  if (kb->keys) g_free(kb->keys);
-  if (kb->desc) g_free(kb->desc);
-  if (kb->command) g_free(kb->command);
+  g_free(kb->keys);
+  g_free(kb->desc);
+  g_free(kb->command);
   g_free(kb);
 }
Index: keymap.c
===================================================================
--- keymap.c	(revision 47e0a6a50d1c08ec05030b2507b3f1a84b618a9f)
+++ keymap.c	(revision 4c7c21f786a0416a755645b78db0b851f75f8748)
@@ -9,7 +9,7 @@
 {
   if (!name || !desc) return(-1);
-  if ((km->name = g_strdup(name)) == NULL) return(-1);
-  if ((km->desc = g_strdup(desc)) == NULL) return(-1);
-  if (0 != owl_list_create(&km->bindings)) return(-1);
+  km->name = g_strdup(name);
+  km->desc = g_strdup(desc);
+  owl_list_create(&km->bindings);
   km->parent = NULL;
   km->default_fn = default_fn;
@@ -179,10 +179,9 @@
 /* NOTE: keyhandler has private access to the internals of keymap */
 
-int owl_keyhandler_init(owl_keyhandler *kh)
-{
-  if (0 != owl_dict_create(&kh->keymaps)) return(-1); 
+void owl_keyhandler_init(owl_keyhandler *kh)
+{
+  owl_dict_create(&kh->keymaps);
   kh->active = NULL;
   owl_keyhandler_reset(kh);
-  return(0);
 }
 
Index: list.c
===================================================================
--- list.c	(revision ddbbcffae8064f4d266a9735a16225e4feef1a3c)
+++ list.c	(revision fda61d3fe64381f30e32bc0091ab5ab59d95524f)
@@ -5,11 +5,9 @@
 #define GROWBY 3 / 2
 
-int owl_list_create(owl_list *l)
+void owl_list_create(owl_list *l)
 {
   l->size=0;
   l->list=g_new(void *, INITSIZE);
   l->avail=INITSIZE;
-  if (l->list==NULL) return(-1);
-  return(0);
 }
 
